﻿/*
 * Created by SharpDevelop.
 * User: Maciek
 * Date: 2015-06-30
 * Time: 18:15
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.IO;
using System.Text;
using NUnit.Framework;
using OpenQA.Selenium;
using OpenQA.Selenium.Support.PageObjects;
using OpenQA.Selenium.Support.UI;

namespace PierwszaSolucja
{
	/// <summary>
	/// Description of ZakupBiletu.
	/// </summary>
	public class ZakupBiletu : PKSZielonaGora
	{
		public IWebDriver driver;
		
		[FindsBy(How = How.LinkText, Using = "Kup bilet miesięczny")]
		private IWebElement zakupBiletuMiesiecznego;
		
		[FindsBy(How = How.Id, Using = "poczatek")]
		private IWebElement miejscowoscPoczatkowa;
		
		[FindsBy(How = How.Id, Using = "koniec")]
		private IWebElement miejscowoscDocelowa;
		
		[FindsBy(How = How.Id, Using = "kierunek_tamipowrot")]
		private IWebElement biletTamIPowrot;
		
		[FindsBy(How = How.Id, Using = "godz_tam")]
		private IWebElement godzinaTam;
		
		[FindsBy(How = How.Id, Using = "godz_powrot")]
		private IWebElement godzinaPowrot;
		
		[FindsBy(How = How.Id, Using = "pom_b")]
		private IWebElement przyciskDalej;
		
		public ZakupBiletu(IWebDriver driver)
		{
			this.driver = driver;
		}
		
		public void ZrobZdjecie(string nazwaZdjecia)
		{
			Screenshot ss = ((ITakesScreenshot)driver).GetScreenshot();
			ss.SaveAsFile(@"C:\Test\" + nazwaZdjecia + ".png", System.Drawing.Imaging.ImageFormat.Png);
		}
		
		public void ZapiszWynikiDoPliku(string nazwaCzynnosci, string opisTestu)
		{
			string data = DateTime.Today.ToShortDateString();
			data = data.Replace(":", "-");
			
			string fileName = @"C:\Testowo\" + @"raport" + data + ".csv";
			
			StreamWriter writer;
			using (writer = new StreamWriter(fileName, true, Encoding.UTF8))
	       {
			    writer.WriteLine("Godzina " + DateTime.Now.ToLongTimeString());
			    writer.WriteLine(nazwaCzynnosci + ";" + opisTestu);
	       }
		}
		
		public void PrzejdzDoZakupuBiletuMiesiecznego()
		{
			zakupBiletuMiesiecznego.Click();
		}
		
		public void WyborMiejscowosci()
		{
			new SelectElement(miejscowoscPoczatkowa).SelectByIndex(1);
			new SelectElement(miejscowoscDocelowa).SelectByIndex(0);
		}
		
		public void WyborTrasyIGodzin(string godzTam, string godzPowrot)
		{
			biletTamIPowrot.Click();
			godzinaTam.SendKeys(godzTam);
			
			if(godzinaPowrot.Enabled)
			{
				godzinaPowrot.SendKeys(godzPowrot);
			}
		}
		
		public void KupBilet(string godzinaTam, string godzinaPowrot)
		{
			PrzejdzDoZakupuBiletuMiesiecznego();
			WyborMiejscowosci();
			WyborTrasyIGodzin(godzinaTam, godzinaPowrot);
			ZapiszWynikiDoPliku("Nazwa testu: ", TestContext.CurrentContext.Test.Name);
			ZapiszWynikiDoPliku("Wprowadzone dane: ", "Mijescowość początkowa: " + ";" + new SelectElement(miejscowoscPoczatkowa).SelectedOption.Text + ";" + " Miejscowość docelowa: " + ";" + new SelectElement(miejscowoscDocelowa).SelectedOption.Text);
		}
	}
}
